const {Html5RPCService} = require("./index");
var ByteBuffer = require('byte');
const hessian = require('hessian.js');
const debug = require('debug')('gongbin:TestWebSocketRPC');
var fs = require('fs');
const path = require('path');
var image = require("imageinfo");

let html5RPCService = new Html5RPCService("ws://192.168.1.25:8080/websocket",(data)=>{
    console.log("链接成功===============:"+data);
},(data)=>{
     console.log("链接失败================:"+data);
});


let pkgName = "";
let methodName = "";

let onSucess = function(event){
    console.log("方法调用成功:"+event.result.img.toString());
    
}

let onFailure = function(event){
    console.log("方法调用失败:"+event.errorCode+":"+event.reason+":"+event.detail);
}

setTimeout(() => {
    // 简单类型
    // testSimpleType('WZYY');
    // testSimpleType(123.3456799217984969484894984984984949844964646464984494984);
    // testSimpleType(false);
    // testSimpleType(['你好','!@##@$#$%^$^%&','我是一段中文。。。']);
    // testSimpleType(['hello', 'nihao', ['lili', ['lycy', ['hahaha']]]]);
    
    // 二进制类型
    testByteType();
    
    // Map类型
    // testMapType();
    
    // 复杂类型
     //testComplexType(1);
    // testComplexType(8);
    // testMapType();
}, 1000);


let testSimpleType = function(val){
    html5RPCService.sendSimple(pkgName,methodName,val,onSucess,onFailure,"abcde");
}

let testMapType = function(){
    // const map = [[1, 'x'], [2, 'y'], [3, 'z']];

    var m = new Map();
    m.set(1, "black");
    m.set(2, "red");
    m.set("colors", 2.51555);
    m.set({x:1}, 33333333);

    let myData2 = {
        $class:"com.baosiling.testboot.model.PersonG",
        $:{
            name:"Tom",
            age:21,  
            married:m
        }
    }
    html5RPCService.send(pkgName,methodName,m,onSucess,onFailure,"abcde");
}

let stringToBytes = function(str) {  

    var ch, st, re = []; 
    for (var i = 0; i < str.length; i++ ) { 
        ch = str.charCodeAt(i);  // get char  
        st = [];                 // set up "stack"  

       do {  
            st.push( ch & 0xFF );  // push byte to stack  
            ch = ch >> 8;          // shift value down by 1 byte  
        }    

        while ( ch );  
        re = re.concat( st.reverse() ); 
    }  
    return re;  
} 

let testByteType = function(){
    // var array = new Uint8Array(10);
    // for (let i=0;i<10;i++) {
    //     array[i] = parseInt(Math.random()*0xFF);
    // }
    // console.log('__________________________________________数组长度:'+array.length);
    // // array[0] = parseInt(Math.random()*0xFF);
    // // array[1] = parseInt(Math.random()*0xFF);
    // // array[2] = parseInt(Math.random()*0xFF);
    // // array[3] = parseInt(Math.random()*0xFF);
    // html5RPCService.send(pkgName,methodName,array,onSucess,onFailure,"abcde");

    let onSucess1 = function(event){
        console.log("方法调用成功:"+event.result.img.toString());
        
    }
    
    let onFailure1 = function(event){
        console.log("方法调用失败:"+event.errorCode+":"+event.reason+":"+event.detail);
    }

    const _path = path.join(__dirname, 'assets.rar');

    fs.readFile(_path, 'binary', function(err, data) {
        if(data) {
            var b1 = new Buffer(data);
            Buffer.prototype.toByteArray = function () {
                return Array.prototype.slice.call(this, 0);
            }
           // var b2 = b1.toByteArray();
           // console.log('__________________________________________数组长度:'+b2.length);

            // let  newBuf = new ByteBuffer(1);
            // newBuf.put(48,0,1);

            // var b1 = new Buffer(48);
            //var w_data = '这是一段通过fs.writeFile函数写入的内容；\r\n';
 
            //b1 = new Buffer(w_data);
            
             var b2 = undefined;//b1.toByteArray();
            let buf = hessian.encode(48, '2.0');

            let myData0 = {
                $class:"com.baosiling.testboot.model.PersonH",
                $:{
                    img:b1
                }
            }


            let myData = {
                $class:"com.baosiling.testboot.model.PersonE",
                $:{
                    name:"Tom",
                    age:21,
                    img:buf,
                    son:{
                        $class: 'com.baosiling.testboot.model.SonA',
                        $:{
                            name: 'jerry', 
                            interest : 'basketball'
                        }
                    }
                }
            }
        
            let myData2 = {
                $class:"com.baosiling.testboot.model.PersonF",
                $:{
                    name:"Tom",
                    age:21,
                    son:{
                        $class: 'com.baosiling.testboot.model.SonE',
                        $:{
                            name: 'jerry', 
                            interest : 'basketball',
                            img : b2
                        }
                    }
                }
            
            }
        
            html5RPCService.send(pkgName,methodName,myData0,onSucess1,onFailure1,"abcde");
        }
        if(err) return console.log(err);
    })

}

let testComplexType = function(model){
    let testModel;
    switch (model) {
        case 1:
            testModel = {
                $class: 'com.baosiling.testboot.model.EmployeeA',
                $:{
                    name:"Tom",
                    age:21,
                    married:false
                }
            }
            break;
        case 2:
            testModel = {
                $class: 'com.baosiling.testboot.model.EmployeeB',
                $:{
                    name:"Tom",
                    age:21,
                    married:false,
                    interest:['basketball', 'footbal']
                }
            }
            break;
        case 3:
            testModel = {
                $class: 'com.baosiling.testboot.model.EmployeeC',
                $:{
                    name:"Tom",
                    age:21,
                    married:false,
                    interest:[{
                        $class: 'com.baosiling.testboot.model.InterestA',
                        $:{
                            name:'basketball',
                            time:2,
                            like:true
                        }
                    },{
                        $class: 'com.baosiling.testboot.model.InterestA',
                        $:{
                            name:'football',
                            time:3,
                            like:false
                        }
                    }]
                }
            }
            break;
        case 4:
            testModel = {
                $class: 'com.baosiling.testboot.model.EmployeeD',
                $:{
                    name:"Tom",
                    age:21,
                    married:false,
                    interest:[{
                        $class: 'com.baosiling.testboot.model.InterestB',
                        $:{
                            name:'basketball',
                            time:2,
                            like:true,
                            desc: ['非常喜欢', '特别喜欢']
                        }
                    },{
                        $class: 'com.baosiling.testboot.model.InterestB',
                        $:{
                            name:'football',
                            time:3,
                            like:false,
                            desc: ['最近很喜欢', '将来不喜欢']
                        }
                    }]
                }
            }
            break;
        case 5:
            testModel = {
                $class: 'com.baosiling.testboot.model.EmployeeE',
                $:{
                    name:"Tom",
                    age:21,
                    married:false,
                    interest:[{
                        $class: 'com.baosiling.testboot.model.InterestC',
                        $:{
                            name:'basketball',
                            time:2,
                            like:true,
                            desc: ['非常喜欢', '特别喜欢'],
                            instruction: {
                                $class: 'com.baosiling.testboot.model.Instruction',
                                $:{
                                    size : 'middle',
                                    color : 'red'
                                }
                            }
                        }
                    },{
                        $class: 'com.baosiling.testboot.model.InterestC',
                        $:{
                            name:'football',
                            time:3,
                            like:false,
                            desc: ['最近很喜欢', '将来不喜欢'],
                            instruction: {
                                $class: 'com.baosiling.testboot.model.Instruction',
                                $:{
                                    size : 'small', 
                                    color : 'white'
                                }
                            }
                        }
                    }]
                }
            }
            break;
        case 6:
            testModel = {
                $class: 'com.baosiling.testboot.model.EmployeeF',
                $:{
                    name:"Tom",
                    age:21,
                    married:false,
                    interest:[{
                        $class: 'com.baosiling.testboot.model.InterestD',
                        $:{
                            name:'basketball',
                            time:2,
                            like:true,
                            instruction: [{
                                $class: 'com.baosiling.testboot.model.Instruction',
                                $:{
                                    size : 'middle', 
                                    color : 'red'
                                }
                            }]
                        }
                    },{
                        $class: 'com.baosiling.testboot.model.InterestD',
                        $:{
                            name:'football',
                            time:3,
                            like:false,
                            instruction: [{
                                $class: 'com.baosiling.testboot.model.Instruction',
                                $:{
                                    size : 'small', 
                                    color : 'white'
                                }
                            }]
                        }
                    }]
                }
            }
            break;
        case 7:
            testModel = {
                $class: 'com.baosiling.testboot.model.PersonA',
                $:{
                    name:"Tom",
                    age:21,
                    son:{
                        $class: 'com.baosiling.testboot.model.SonA',
                        $:{
                            name: 'jerry', 
                            interest : 'basketball'
                        }
                    }
                }
            }
            break;
        case 8:
            testModel = {
                $class: 'com.baosiling.testboot.model.PersonB',
                $:{
                    name:"Tom",
                    age:21,
                    son:{
                        $class: 'com.baosiling.testboot.model.SonB',
                        $:{
                            name: 'jerry', 
                            interest : 'basketball',
                            wife: {
                                $class: 'com.baosiling.testboot.model.WifeA',
                                $:{
                                    name : 'lily', 
                                    job : 'java', 
                                    age : 25
                                }
                            }
                        }
                    }
                }
            }
            break;
        case 9:
            testModel = {
                $class: 'com.baosiling.testboot.model.PersonC',
                $:{
                    name:"Tom",
                    age:21,
                    son:{
                        $class: 'com.baosiling.testboot.model.SonC',
                        $:{
                            name: 'jerry', 
                            interest : 'basketball',
                            wife:{
                                $class: 'com.baosiling.testboot.model.WifeB',
                                $:{
                                    name : 'lily', 
                                    job : 'java', 
                                    age : 25,
                                    car : {
                                        $class: 'com.baosiling.testboot.model.Car',
                                        $:{
                                            brand : 'audi', 
                                            speed : 200
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            break;
        case 10:
            testModel = {
                $class: 'com.baosiling.testboot.model.PersonD',
                $:{
                    name:"Tom",
                    age:21,
                    son:{
                        $class: 'com.baosiling.testboot.model.SonD',
                        $:{
                            name: 'jerry', 
                            interest : 'basketball',
                            wife:[{
                                $class: 'com.baosiling.testboot.model.WifeB',
                                $:{
                                    name : 'lily', 
                                    job : 'java', 
                                    age : 25,
                                    car : {
                                        $class: 'com.baosiling.testboot.model.Car',
                                        $:{
                                            brand : 'audi', 
                                            speed : 200
                                        }
                                    }
                                }
                            },{
                                $class: 'com.baosiling.testboot.model.WifeB',
                                $:{
                                    name : 'lucy', 
                                    job : 'h5', 
                                    age : 30,
                                    car : {
                                        $class: 'com.baosiling.testboot.model.Car',
                                        $:{
                                            brand : 'bmw', 
                                            speed : 250
                                        }
                                    }
                                }
                            }]
                        }
                    }
                }
            }
            break;
    }

    html5RPCService.send(pkgName,methodName,testModel,onSucess,onFailure,"abcde");
}


