'use strict';
/**
 * Created by gongbin on 2017/6/23.
 */


const hessian = require('hessian.js');
const debug = require('debug')('gongbin:Html5TopicManager');

class Html5TopicManagerImpl{


    constructor(){
        this.observerMap = new Map();

        this.messagePackageDataMap = new Map();
    }

    addTopicObserver(topicName,callBack){
        let callBackSet = null;
        if(this.observerMap.has(topicName)){
            callBackSet = this.observerMap.get(topicName);
        }
        else{
            callBackSet = new Set();
            this.observerMap.set(topicName,callBackSet);
        }
        callBackSet.add(callBack);
    }

    removeTopicObserver(topicName,callBack){
        if(this.observerMap.has(topicName)){
            let callBackSet = this.observerMap.get(topicName);
            callBackArr.delete(callBack);
        }
    }


    onTopicMessage(message){
        let topicName = message.topicName;
        if(this.observerMap.has(topicName)){
            let  callBackSet = this.observerMap.get(topicName);
            for(let callBack of callBackSet){
                callBack.apply(null,[message.jsmObj]);
            }
        }
    }


    doTopicMessage(messagePackageData){
        if(messagePackageData.packetNum == 1){//不分包
            try {
                let messageData = hessian.decode(messagePackageData.responseInfoBytes, '2.0');
                onTopicMessage(messageData);
                }
            catch(err){
                    debug("通知解析出错:"+err.message);
            }

        }
        else{//分包
            let messageMapData = null;
            if(this.messagePackageDataMap.has(messagePackageData.uuid)){
                messageMapData = this.messagePackageDataMap.get(messagePackageData.uuid);
            }
            else{
                messageMapData = {"totalLength":0,"dataMap":[]};
                this.messagePackageDataMap.set(messagePackageData.uuid,messageMapData);
            }

            messageMapData.totalLength+= messagePackageData.responseInfoBytes.length;
            messageMapData.dataMap[messagePackageData.packetIndex-1] = messagePackageData.responseInfoBytes;
            if(messageMapData.dataMap.size == messagePackageData.packetNum){
                var isAllData = true;
                for(let i = 0 ; i < messagePackageData.packetNum;i++){
                    if(messageMapData.dataMap[i] == undefined){
                        isAllData = false;
                        break;
                    }
                }

                if(isAllData == true){
                    let  newBuf = new ByteBuffer({size: this.packageDataToalLength})
                    for(let j = 0 ; j < messagePackageData.packetNum; j++){
                        let packageBuf =  messageMapData.dataMap[j];
                        newBuf.put(packageBuf,0,packageBuf.length);
                    }

                    let copyBuf = newBuf.copy();




                    messageMapData.dataMap = null;

                    this.messagePackageDataMap.delete(messagePackageData.uuid);

                    try {
                        let messageData1 = hessian.decode(copyBuf, '2.0');
                        onTopicMessage(messageData1);
                    }catch(err){
                            debug("通知解析出错:"+err.message);
                    }


                }


            }

        }
    }
}

const html5TopicManagerImpl = new Html5TopicManagerImpl();

class Html5TopicManager{

    static getInstance(){
        return html5TopicManagerImpl;
    }

}

module.exports = Html5TopicManager;
